/**
  ******************************************************************************
  * @file    vk16d33_driver.c
  * @author  kevin_guo
  * @version V1.0.0
  * @date    06-05-2019
  * @brief   This file provides tuner io i2c vk16d33_driver functions.
  ******************************************************************************
  * @copy
  */ 
  
/* Includes ------------------------------------------------------------------*/
#include "vk16d33_driver.h"

/* extern variables ----------------------------------------------------------*/
unsigned char write_buf[16];
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private function ----------------------------------------------------------*/

/*******************************************************************************
* Function Name  : VK16D33_delay_nus
* Description    : ʱ1uS
* Input          : n->ʱʱnuS
* Output         : None
* Return         : None
*******************************************************************************/
void VK16D33_delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}
/*******************************************************************************
* Function Name  : delay_nms
* Description    : ʱ1mS
* Input          : n->ʱʱnmS
* Output         : None
* Return         : None
*******************************************************************************/
void VK16D33_delay_nms(unsigned long int n)
{
	while(n--)
	{
		VK16D33_delay_nus(1000);
	}
}
//===============================================================================
//GPIO ģI2C 
/*************************************************************
*ƣVK16D33_I2CStart
*ܣI2Cʼź
*
*
*    עʱ߸ʱɸߵ͵䣬ʾI2Cʼź
**************************************************************/
void VK16D33_I2CStart( void )
{
  VK16D33_SDA_HIGH;
  VK16D33_delay_nus(1);
  VK16D33_SCL_HIGH;
  VK16D33_delay_nus(1);
  VK16D33_SDA_LOW;
  VK16D33_delay_nus(1);
}

/*************************************************************
*ƣVK16D33_I2CStop
*ܣI2Cֹͣź
*
*
*    עʱ߸ʱɵ͵ߵ䣬ʾI2Cֹͣź
**************************************************************/
void VK16D33_I2CStop( void )
{
  VK16D33_SDA_LOW;
  VK16D33_delay_nus(1);
  VK16D33_SCL_HIGH;
  VK16D33_delay_nus(1);
  VK16D33_SDA_HIGH;
  VK16D33_delay_nus(1);

  VK16D33_SCL_LOW;
}

/*************************************************************
*ƣVK16D33_I2CSlaveAck
*ܣI2Cӻ豸Ӧѯ
*
*
*    ע
**************************************************************/
unsigned char VK16D33_I2CSlaveAck( void )
{
  unsigned int TimeOut;
  unsigned char RetValue;
	
//  VK16D33_DIRSDA_IN;//ƬSDAΪIOҪΪ
  VK16D33_SCL_LOW;
  VK16D33_delay_nus(1);
  VK16D33_SCL_HIGH;//9SCL
  TimeOut = 10000;
  while( TimeOut-- > 0 )//ȡack
  {
    if( VK16D33_SDA_IO==0 )
    {
      RetValue = 0;
      break;
    }
    else
    {
      RetValue = 1;
    }
  }
//  VK16D33_DIRSDA_OUT;//ƬSDAΪIOҪΪ
  return RetValue;
}

/*************************************************************
*ƣVK16D33_I2CWriteByte
*ܣI2Cдһֽ
*
*
*    ע
**************************************************************/
void VK16D33_I2CWriteByte( unsigned char byte )
{
  unsigned char i;

  for( i=0; i<8; i++ )
  {
    VK16D33_SCL_LOW;
    if( 0X80 & byte )
      VK16D33_SDA_HIGH;
    else
      VK16D33_SDA_LOW;
    byte <<= 1;
    VK16D33_delay_nus(1);
    VK16D33_SCL_HIGH;
    VK16D33_delay_nus(1);		
  }
  VK16D33_SCL_LOW;
}

/*************************************************************
*: VK16D33WriteCmd
*: I2C_IOVK16D33дһֽ
*: cmd  д
*0: д1:д
*    ע
**************************************************************/
unsigned char VK16D33WriteCmd(unsigned char reg,unsigned char para )
{
  VK16D33_I2CStart();
	
  VK16D33_I2CWriteByte( VK16D33_DEVADDR|0x00 );
  if( 1 == VK16D33_I2CSlaveAck() )
  {
    return 1;
  }
  VK16D33_I2CWriteByte( reg );
  if( 1 == VK16D33_I2CSlaveAck() )
  {
    return 1;
  }
  VK16D33_I2CWriteByte( para );
  if( 1 == VK16D33_I2CSlaveAck() )
  {
    return 1;
  }
  VK16D33_I2CStop();
 
  return 0;
}

/*************************************************************
*: VK16D33WriteOneData
*: I2C_IOVK16D33д1ֽ
*: addr  дĵַ
*          data  д
*0: д1:д
*    ע
**************************************************************/
unsigned char VK16D33WriteOneData( unsigned char addr, unsigned char data )
{
	//START ź
  VK16D33_I2CStart();
  //SLAVEַ
  VK16D33_I2CWriteByte( VK16D33_DEVADDR|0x00 );
  if( 1 == VK16D33_I2CSlaveAck() )
  {
    return 1;
  }
	//ʾRAMַ
  VK16D33_I2CWriteByte( addr );
  if( 1 == VK16D33_I2CSlaveAck() )
  {
    return 1;
  }
	//ʾ
  VK16D33_I2CWriteByte( data );
  if( 1 == VK16D33_I2CSlaveAck() )
  {
    return 1;
  }
	//STOPź
  VK16D33_I2CStop();	
 
  return 0;
}
/*************************************************************
*: VK16D33WriteNData
*: I2C_IOVK16D33д1ֽ/ַnֽ
*: addr      дĵַ
*					 databuf   ݻ
*          num       дݸ
*0:      д1:д
*    ע
**************************************************************/
unsigned char VK16D33WriteNData( unsigned char addr, unsigned char* databuf, unsigned char num)
{
	unsigned char i;
	//STARTź		
  VK16D33_I2CStart();
	//SLAVEַ
  VK16D33_I2CWriteByte( VK16D33_DEVADDR|0x00 );
  if( 1 == VK16D33_I2CSlaveAck() )
  {
    return 1;
  }
  //дʾRAMַ
  VK16D33_I2CWriteByte( addr );
  if( 1 == VK16D33_I2CSlaveAck() )
  {
    return 1;
  }
	//numݵʾRAM
	for(i=0;i<num;i++)
	{
		VK16D33_I2CWriteByte(*databuf++);
		if( 1 == VK16D33_I2CSlaveAck() )
		{
			return 1;
		}
	}
	//STOPź
  VK16D33_I2CStop();	
 
  return 0;
}
/*******************************************************************************
* Function Name  : Vk16d33_Init
* Description    : Vk16d33ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Vk16d33_Init(void)
{	
	unsigned char i;
	//ͨߵƽͬӵƽת·
	//˺ݿͻƬӦ޸	
	GPIO_SetMode(VK16D33_SCL_PORT, VK16D33_SCL_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK16D33_SDA_PORT, VK16D33_SDA_PIN, GPIO_MODE_QUASI);
	
	VK16D33_SCL_HIGH;
	VK16D33_SDA_HIGH; 
	
	VK16D33WriteCmd(VK16D33_CTRL_REG,NOMAL_DISPOFF); //״̬ʾ	
	//0x00 0x01 0x02 0x03 0x04 0x05 0x06 0x07 0x08 0x09 0x0a 0x0b 0x0c 0x0d 0x0e 0x0f
	//4.37 8.75 13.1 17.5 21.9 26.3 30.6 35.0 39.4 43.6 48.1 52.5 56.9 61.3 65.6 70.0  (mA)
	VK16D33WriteCmd(VK16D33_SEGI_REG,0x07); 	//ʾ0x00-0x0f
	//0x0f 0x0e 0x0d 0x0c 0x0b 0x0a 0x09 0x08 0x07 0x06 0x05 0x04 0x03 0x02 0x01 0x00
	//16λ 15λ 14λ 13λ 12λ 11λ 10λ 9λ  8λ  7λ  6λ  5λ  4λ  3λ  2λ  1λ
	VK16D33WriteCmd(VK16D33_GSCAN_REG,0x0f); 	//GRID	Ĭ16λ
	for(i=0;i<16;i++)
	{
		write_buf[i]=0x00;
	}
	VK16D33WriteNData(0x00,write_buf,16);   //ȫ
	VK16D33WriteCmd(VK16D33_CTRL_REG,NOMAL_DISPON); //״̬ʾ	
}
 
/*******************************************************************************
* Function Name  : VK16D33_Main
* Description    : vk16d33Գ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void VK16D33_Main(void)
{   
	unsigned char i,j;
		 
	Vk16d33_Init();	  
	while(1)
	{
		for(i=0;i<16;i++)
		{
			write_buf[i]=0xff;
		}
	  VK16D33WriteNData(0x00,write_buf,16);   //ȫ
		VK16D33_delay_nms(1000); 
		for(i=0;i<16;i++)
		{
			write_buf[i]=0x00;
		}
		VK16D33WriteNData(0x00,write_buf,16);   //ȫ
		VK16D33_delay_nms(1000); 

		for(j=0;j<16;j++)
		{
			for(i=0;i<16;i++)
			{
				write_buf[i]=0x00;
			}
			write_buf[j]=0xff;
			VK16D33WriteNData(0x00,write_buf,16);
			VK16D33_delay_nms(1000); 
		}
		VK16D33_delay_nms(1000); 
		for(j=0;j<8;j+=1)
		{
			for(i=0;i<16;i+=1)
			{
				write_buf[i]=1<<j;
			}
			VK16D33WriteNData(0x00,write_buf,16);
			VK16D33_delay_nms(1000); 
		}
		for(i=0;i<16;i+=1)
		{
			write_buf[i]=0;
		}
		VK16D33WriteNData(0x00,write_buf,16);
		VK16D33_delay_nms(1000); 
		 		
		VK16D33WriteOneData(0x00, 0xff); 
		VK16D33_delay_nms(1000);  
		__nop();
	}
}   
/************************END OF FILE****/ 
